/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AuthMFARequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AuthMFARequest{}

// AuthMFARequest struct for AuthMFARequest
type AuthMFARequest struct {
	Session *string `json:"session,omitempty"`
	Email   *string `json:"email,omitempty"`
	Code    *string `json:"code,omitempty"`
}

// NewAuthMFARequest instantiates a new AuthMFARequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuthMFARequest() *AuthMFARequest {
	this := AuthMFARequest{}
	return &this
}

// NewAuthMFARequestWithDefaults instantiates a new AuthMFARequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuthMFARequestWithDefaults() *AuthMFARequest {
	this := AuthMFARequest{}
	return &this
}

// GetSession returns the Session field value if set, zero value otherwise.
func (o *AuthMFARequest) GetSession() string {
	if o == nil || IsNil(o.Session) {
		var ret string
		return ret
	}
	return *o.Session
}

// GetSessionOk returns a tuple with the Session field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthMFARequest) GetSessionOk() (*string, bool) {
	if o == nil || IsNil(o.Session) {
		return nil, false
	}
	return o.Session, true
}

// HasSession returns a boolean if a field has been set.
func (o *AuthMFARequest) HasSession() bool {
	if o != nil && !IsNil(o.Session) {
		return true
	}

	return false
}

// SetSession gets a reference to the given string and assigns it to the Session field.
func (o *AuthMFARequest) SetSession(v string) {
	o.Session = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *AuthMFARequest) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthMFARequest) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *AuthMFARequest) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *AuthMFARequest) SetEmail(v string) {
	o.Email = &v
}

// GetCode returns the Code field value if set, zero value otherwise.
func (o *AuthMFARequest) GetCode() string {
	if o == nil || IsNil(o.Code) {
		var ret string
		return ret
	}
	return *o.Code
}

// GetCodeOk returns a tuple with the Code field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthMFARequest) GetCodeOk() (*string, bool) {
	if o == nil || IsNil(o.Code) {
		return nil, false
	}
	return o.Code, true
}

// HasCode returns a boolean if a field has been set.
func (o *AuthMFARequest) HasCode() bool {
	if o != nil && !IsNil(o.Code) {
		return true
	}

	return false
}

// SetCode gets a reference to the given string and assigns it to the Code field.
func (o *AuthMFARequest) SetCode(v string) {
	o.Code = &v
}

func (o AuthMFARequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AuthMFARequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Session) {
		toSerialize["session"] = o.Session
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Code) {
		toSerialize["code"] = o.Code
	}
	return toSerialize, nil
}

type NullableAuthMFARequest struct {
	value *AuthMFARequest
	isSet bool
}

func (v NullableAuthMFARequest) Get() *AuthMFARequest {
	return v.value
}

func (v *NullableAuthMFARequest) Set(val *AuthMFARequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthMFARequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthMFARequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthMFARequest(val *AuthMFARequest) *NullableAuthMFARequest {
	return &NullableAuthMFARequest{value: val, isSet: true}
}

func (v NullableAuthMFARequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthMFARequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
